
-- Unique spin ability for Jason, the Hammer Spin, let's start: (Manimi's here-)

local maxamountoftime = 8*TICRATE //The limit you can use the spin in TICRATEs.
local nauseatimer = TICRATE //The amount of seconds you become nausea after reaching the limit.

local blacklistobjects = 	{
								MT_LASER, MT_EGGMOBILE_FIRE, MT_CRUSHCLAW,
								MT_CACTI1, MT_CACTI2, MT_CACTI3, MT_CACTI4, MT_CACTI5,
								MT_CACTI6, MT_CACTI7, MT_CACTI8, MT_CACTI9, MT_CACTI10,
								MT_CACTI11, MT_CACTITINYSEG, MT_CACTISMALLSEG,
								MT_CYBRAKDEMON_ELECTRIC_BARRIER, MT_CYBRAKDEMON_FLAMEREST
							}
							
freeslot("sfx_jsntnt")
sfxinfo[sfx_jsntnt].caption = "Taunt"

freeslot("SPR_JDIZ", "SPR_MARK", "SPR_JSPN", "SPR_CTRL")
freeslot("S_VOID", "S_JASONREFLECTOVERLAY")
freeslot("MT_JASONOVERLAY")

for i = 2, 8
	freeslot("S_JASONREFLECTOVERLAY"..i)
end

for i = 1, 8
	freeslot("S_JASONREFLECTSPIN"..i)
end

for i = 1, 4
	freeslot("S_JASONSPIN"..i)
end

for i = 1, 2
	freeslot("S_JASONNAUSEA"..i)
	
	freeslot("S_JASONWARNING"..i)
	freeslot("S_JASONMADWARNING"..i)
end

for i = 1, 16
	freeslot("S_JASONCONFUSION"..i)
end

states[S_JASONREFLECTOVERLAY] = {SPR_FORC, U|TR_TRANS10, 1, nil, 0, 0, S_JASONREFLECTOVERLAY2}
states[S_JASONREFLECTOVERLAY2] = {SPR_FORC, U|TR_TRANS20, 1, nil, 0, 0, S_JASONREFLECTOVERLAY3}
states[S_JASONREFLECTOVERLAY3] = {SPR_FORC, U|TR_TRANS30, 1, nil, 0, 0, S_JASONREFLECTOVERLAY4}
states[S_JASONREFLECTOVERLAY4] = {SPR_FORC, U|TR_TRANS40, 1, nil, 0, 0, S_JASONREFLECTOVERLAY5}
states[S_JASONREFLECTOVERLAY5] = {SPR_FORC, U|TR_TRANS50, 1, nil, 0, 0, S_JASONREFLECTOVERLAY6}
states[S_JASONREFLECTOVERLAY6] = {SPR_FORC, U|TR_TRANS60, 2, nil, 0, 0, S_JASONREFLECTOVERLAY7}
states[S_JASONREFLECTOVERLAY7] = {SPR_FORC, U|TR_TRANS70, 2, nil, 0, 0, S_JASONREFLECTOVERLAY8}
states[S_JASONREFLECTOVERLAY8] = {SPR_FORC, U|TR_TRANS80, 2, nil, 0, 0, S_JASONREFLECTOVERLAY8}

states[S_VOID] = {SPR_CTRL, A, -1, nil, 0, 0, S_VOID}

states[S_JASONREFLECTSPIN1] = {SPR_JSPN, A, 1, nil, 0, 0, S_JASONREFLECTSPIN2}
states[S_JASONREFLECTSPIN2] = {SPR_JSPN, B, 1, nil, 0, 0, S_JASONREFLECTSPIN3}
states[S_JASONREFLECTSPIN3] = {SPR_JSPN, C, 1, nil, 0, 0, S_JASONREFLECTSPIN4}
states[S_JASONREFLECTSPIN4] = {SPR_JSPN, D, 1, nil, 0, 0, S_JASONREFLECTSPIN5}
states[S_JASONREFLECTSPIN5] = {SPR_JSPN, A, 1, nil, 0, 0, S_JASONREFLECTSPIN6}
states[S_JASONREFLECTSPIN6] = {SPR_JSPN, B, 1, nil, 0, 0, S_JASONREFLECTSPIN7}
states[S_JASONREFLECTSPIN7] = {SPR_JSPN, C, 1, nil, 0, 0, S_JASONREFLECTSPIN8}
states[S_JASONREFLECTSPIN8] = {SPR_JSPN, D, 1, nil, 0, 0, S_JASONSPIN1}

states[S_JASONSPIN1] = {SPR_JSPN, A, 2, nil, 0, 0, S_JASONSPIN2}
states[S_JASONSPIN2] = {SPR_JSPN, B, 2, nil, 0, 0, S_JASONSPIN3}
states[S_JASONSPIN3] = {SPR_JSPN, C, 2, nil, 0, 0, S_JASONSPIN4}
states[S_JASONSPIN4] = {SPR_JSPN, D, 2, nil, 0, 0, S_JASONSPIN1}

states[S_JASONNAUSEA1] = {SPR_JDIZ, A, 10, nil, 0, 0, S_JASONNAUSEA2}
states[S_JASONNAUSEA2] = {SPR_JDIZ, B, 10, nil, 0, 0, S_JASONNAUSEA1}

states[S_JASONWARNING1] = {SPR_MARK, A|TR_TRANS50, 10, nil, 0, 0, S_JASONWARNING2}
states[S_JASONWARNING2] = {SPR_MARK, A|TR_TRANS50, 10, nil, 0, 0, S_JASONWARNING1}

states[S_JASONMADWARNING1] = {SPR_MARK, B|TR_TRANS50, 3, nil, 0, 0, S_JASONMADWARNING2}
states[S_JASONMADWARNING2] = {SPR_MARK, B|TR_TRANS50, 3, nil, 0, 0, S_JASONMADWARNING1}

states[S_JASONCONFUSION1] = {SPR_SPRK, A, 1, nil, 0, 0, S_JASONCONFUSION2}
states[S_JASONCONFUSION2] = {SPR_SPRK, B, 1, nil, 0, 0, S_JASONCONFUSION3}
states[S_JASONCONFUSION3] = {SPR_SPRK, C, 1, nil, 0, 0, S_JASONCONFUSION4}
states[S_JASONCONFUSION4] = {SPR_SPRK, D, 1, nil, 0, 0, S_JASONCONFUSION5}
states[S_JASONCONFUSION5] = {SPR_SPRK, E, 1, nil, 0, 0, S_JASONCONFUSION6}
states[S_JASONCONFUSION6] = {SPR_SPRK, F, 1, nil, 0, 0, S_JASONCONFUSION7}
states[S_JASONCONFUSION7] = {SPR_SPRK, G, 1, nil, 0, 0, S_JASONCONFUSION8}
states[S_JASONCONFUSION8] = {SPR_SPRK, H, 1, nil, 0, 0, S_JASONCONFUSION9}
states[S_JASONCONFUSION9] = {SPR_SPRK, I, 1, nil, 0, 0, S_JASONCONFUSION10}
states[S_JASONCONFUSION10] = {SPR_SPRK, H, 1, nil, 0, 0, S_JASONCONFUSION11}
states[S_JASONCONFUSION11] = {SPR_SPRK, G, 1, nil, 0, 0, S_JASONCONFUSION12}
states[S_JASONCONFUSION12] = {SPR_SPRK, F, 1, nil, 0, 0, S_JASONCONFUSION13}
states[S_JASONCONFUSION13] = {SPR_SPRK, E, 1, nil, 0, 0, S_JASONCONFUSION14}
states[S_JASONCONFUSION14] = {SPR_SPRK, D, 1, nil, 0, 0, S_JASONCONFUSION15}
states[S_JASONCONFUSION15] = {SPR_SPRK, C, 1, nil, 0, 0, S_JASONCONFUSION16}
states[S_JASONCONFUSION16] = {SPR_SPRK, B, 1, nil, 0, 0, S_JASONCONFUSION1}

mobjinfo[MT_JASONOVERLAY] = {
	doomednum = -1,
	spawnstate = S_JASONREFLECTSPIN1,
	deathstate = S_JASONREFLECTSPIN1,
	spawnhealth = 6000,
	speed = 1,
	radius = 16*FRACUNIT,
	height = 48*FRACUNIT
}

//jasonmeter command
COM_AddCommand("jasonmeter", function(player, arg)
	if not (player.mo and player.mo.valid) then CONS_Printf(player, "This can only be used in a level!") return end
	if arg
		if arg == "0" or arg == "default"
			player.jasonmeter = 0
			if io and player == consoleplayer
				local file = io.openlocal("client/jason.dat", "w+")
				file:write(0)
				file:close()
			end
		elseif arg == "1"
			player.jasonmeter = 1
			if io and player == consoleplayer
				local file = io.openlocal("client/jason.dat", "w+")
				file:write(1)
				file:close()
			end
		elseif arg == "2"
			player.jasonmeter = 2
			if io and player == consoleplayer
				local file = io.openlocal("client/jason.dat", "w+")
				file:write(2)
				file:close()
			end
		else
			CONS_Printf(player, "jasonmeter - Changes when Jason's spin meter appears.")
			CONS_Printf(player, "#0: Only in first person.")
			CONS_Printf(player, "#1: Only when spinning.")
			CONS_Printf(player, "#2: Always.")
		end
	else
		CONS_Printf(player, "jasonmeter - Changes when Jason's spin meter appears.")
		CONS_Printf(player, "#0: Only in first person.")
		CONS_Printf(player, "#1: Only when spinning.")
		CONS_Printf(player, "#2: Always.")
	end
end, 0)

addHook("PlayerSpawn", function(player)
	//I/O maybe
	if io and player.jasonmeter == nil and player == consoleplayer
		local file = io.openlocal("client/jason.dat")
		if file
			local num = file:read("*n")
			if num != nil and num >= 0 and num <= 2
				COM_BufInsertText(consoleplayer, "jasonmeter "..num)
			end
			file:close()
		end
	end
end)

//Function to spawn particles!

local function SpawnParticles(player)
	local particle = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SPINDUST) //Spawn the dust!
	particle.scale = player.mo.scale/2 //dust will be half the size of the player.
	
	if (player.mo.eflags & MFE_VERTICALFLIP) //if the player is flipped
		P_TeleportMove(particle, player.mo.x, player.mo.y, player.mo.z+player.mo.height-particle.scale) //the particle will spawn from above.
	end
	
	particle.momz = (((P_RandomByte()*player.mo.scale)/255)+player.mo.scale)*P_MobjFlip(player.mo) //the dust goes up! (or down)
	
	local movedirection = R_PointToAngle2(player.cmomx, player.cmomy, player.mo.momx, player.mo.momy)+ANGLE_90 //get the player's movement direction
	P_InstaThrust(particle, movedirection, (((P_RandomByte()*player.mo.scale*2)/255)-player.mo.scale)*16) //Push the particles away from the player's direction!
	
	local distmomx = player.mo.momx-player.cmomx
	local distmomy = player.mo.momy-player.cmomy
	particle.momx = $1 + player.cmomx + (distmomx*2/3)
	particle.momy = $1 + player.cmomy + (distmomy*2/3)
	
	P_TeleportMove(particle, particle.x-particle.momx, particle.y-particle.momy, particle.z+particle.momz) //the particle teleports to his route.
	
	if (P_MobjFlip(player.mo) < 0) //if the player is flipped
		particle.eflags = $1|MFE_VERTICALFLIP //particle is flipped as well!
		particle.flags2 = $1|MF2_OBJECTFLIP
	end
	
	if ((player.mo.eflags & MFE_UNDERWATER) or (player.mo.eflags & MFE_TOUCHWATER)) //if the player is underwater or just touched the water-
	and not (P_PlayerTouchingSectorSpecial(player, 1, 3)) //it's not lava...
		particle.state = S_SPINDUST_BUBBLE1 //the particle will get the bubble effect.
	end
	
	if (P_PlayerTouchingSectorSpecial(player, 1, 3)) //player is touching the lava
		particle.state = S_SPINDUST_FIRE1 //the particle will get the fire effect.
	end
	
	particle.tics = 6 //the particle exists for 6 tics.
end

//Function to find bustable blocks to destroy!

local function DestroyBustables(player, basesector)

	for fof in basesector.ffloors() // Checks for FOFs in your sector.
	
		if not (fof.flags & FF_EXISTS) continue end // Only find "exist" FOFs.
		if not (fof.flags & FF_BUSTUP) continue end // Only find FOFs that are bustable.

		if (player.mo.z >= fof.topheight) // the bustable block is too low
			continue
		end

		if (player.mo.z+player.mo.momz+player.mo.height < fof.bottomheight) // the bustable block is too high
			continue
		end

		EV_CrumbleChain(basesector, fof) // Bust the bustable block!
	end
end

local function CheckBustableCollision(player, basesector)

	local checker = false

	for fof in basesector.ffloors() // Checks for FOFs in your sector.
	
		if not (fof.flags & FF_EXISTS) continue end // Only find "exist" FOFs.
		if not (fof.flags & FF_BUSTUP) continue end // Only find FOFs that are bustable.

		if (player.mo.z >= fof.topheight) // the bustable block is too low
			continue
		end

		if (player.mo.z+player.mo.momz+player.mo.height < fof.bottomheight) // the bustable block is too high
			continue
		end

		checker = true
	end
	
	return checker
end

addHook("PlayerThink", function(player)
	if (player.mo and player.mo.valid) //a quick check to actually check if the player exists inside the map to prevent certain "mo" warnings.
		
		if (player.mo.normalheight == nil)
			player.mo.normalheight = player.height //just to get jason's normal height when changing it-
		end
		
		if (player.mo.boingcooldown == nil)
			player.mo.boingcooldown = 0
		end
		
		if (player.mo.reflectcooldown == nil)
			player.mo.reflectcooldown = 0 //jason reflect cooldown
		end
		
		if (player.mo.reflectwindow == nil)
			player.mo.reflectwindow = 0 //jason reflect cooldown
		end
		
		if (player.mo.jasonspin == nil)
			player.mo.jasonspin = false //jason's unique spin, not activated at the beginning.
		end
		
		if (player.mo.jasonspintimer == nil)
			player.mo.jasonspintimer = 0 //just a timer to keep track of jason's spin attack.
		end
		
		if (player.mo.jasonframenumber == nil)
			player.mo.jasonframenumber = 0 //to help cycle through the spin frames. (0 - A, 1 - B, 2 - C, etc)
		end
		
		if (player.mo.jasonnormalspeed == nil)
			player.mo.jasonnormalspeed = skins["jason"].normalspeed //Jason's normal speed.
		end
		
		if (player.mo.jasonjumpfactor == nil)
			player.mo.jasonjumpfactor = skins["jason"].jumpfactor //Jason's jump factor.
		end
		
		if (player.mo.jasonspinspeed == nil)
			player.mo.jasonspinspeed = 0 //Jason's spinning's speed bonus.
		end
		
		if (player.mo.jasonspinjump == nil)
			player.mo.jasonspinjump = 0 //Jason's spinning's jump bonus.
		end
		
		if (player.mo.jasonnausea == nil)
			player.mo.jasonnausea = false //jason's nausea state, he's gonna get nausea if he uses all his limit.
		end
		
		if (player.mo.jasonnauseatimer == nil)
			player.mo.jasonnauseatimer = 0 //jason's nausea timer, to help keep track of his nausea.
		end
		
		if (player.mo.sparkleangle == nil)
			player.mo.sparkleangle = 0 //Angle for confusion sparkles to move...
		end
		
		if not (player.mo.skin == "jason") //If actually not jason (wtf)
			if (player.mo.reflect and player.mo.reflect.valid)
				P_RemoveMobj(player.mo.reflect)
				player.mo.reflect = nil
			end
			if (player.mo.greenglow and player.mo.greenglow.valid)
				P_RemoveMobj(player.mo.greenglow)
				player.mo.greenglow = nil
			end
			if (player.mo.madgreenglow and player.mo.madgreenglow.valid)
				P_RemoveMobj(player.mo.madgreenglow)
				player.mo.madgreenglow = nil
			end
			if (player.mo.additionalshadow and player.mo.additionalshadow.valid)
				P_RemoveMobj(player.mo.additionalshadow)
				player.mo.additionalshadow = nil
			end
			if (player.mo.warning and player.mo.warning.valid)
				P_RemoveMobj(player.mo.warning)
				player.mo.warning = nil
			end
			if (player.mo.madwarning and player.mo.madwarning.valid)
				P_RemoveMobj(player.mo.madwarning)
				player.mo.madwarning = nil
			end
			if (player.mo.confusionsparkle1 and player.mo.confusionsparkle1.valid)
				P_RemoveMobj(player.mo.confusionsparkle1)
				player.mo.confusionsparkle1 = nil
			end
			if (player.mo.confusionsparkle2 and player.mo.confusionsparkle2.valid)
				P_RemoveMobj(player.mo.confusionsparkle2)
				player.mo.confusionsparkle2 = nil
			end
			if ((player.mo.jasonspin == true) or (player.mo.jasonnausea == true))
				player.mo.state = S_PLAY_FALL
			end
			player.mo.jasonspin = false
			player.mo.jasonnausea = false
		end
		
		//---------------------------------
		//From now on it's jason only time!
		//---------------------------------
		
		if not (player.mo.skin == "jason") return end //this script is only for saj so no need for any other skins.
		
		//lol I'm tacking my stuff at the beginning because I don't wanna
		//mess with all the other stuff
		
		player.hasnomomentum = player.mo.jasonspin
		
		//Detect when we press Custom 1
		if not (player.cmd.buttons & BT_CUSTOM1)
			player.mo.jason1tapready = true
			player.mo.jason1tapping = false
		elseif player.mo.jason1tapready then
			player.mo.jason1tapping = true
			player.mo.jason1tapready = false
		else
			player.mo.jason1tapping = false
		end
		
		if player.mo.jasonnausea or player.pflags&PF_STASIS
		or player.powers[pw_nocontrol] or player.pflags&PF_SLIDING
		or player.iseggrobo or player.isjettysyn
		or player.guard or player.actionstate
		or (P_IsObjectOnGround(player.mo) and player.mo.jasontaunting
		and not (player.mo.flags&MF_NOCLIPHEIGHT))
		or (player.mo.jasonspin and player.mo.jasontaunting)
			if player.mo.jasontaunting
				if player.mo.sprite2 == SPR_TAL0
					if not player.mo.health
						player.mo.state = S_PLAY_DEAD
					elseif P_PlayerInPain(player)
						player.mo.state = S_PLAY_PAIN
					elseif (player.pflags&PF_JUMPED and not (player.pflags&PF_NOJUMPDAMAGE))
					or player.pflags&PF_SPINNING
						player.mo.state = S_PLAY_ROLL
					elseif player.powers[pw_carry] == CR_ROLLOUT
						player.mo.state = S_PLAY_STND
					elseif not P_IsObjectOnGround(player.mo)
						player.mo.state = S_PLAY_JUMP
					end
				end
				player.mo.jasontaunting = 0
			end
		elseif player.mo.jasontaunting
			player.mo.jasontaunting = $-1
			if not P_PlayerInPain(player)
				player.mo.state = S_PLAY_RIDE
			end
			if not player.mo.jasontaunting
				if not player.mo.health
					player.mo.state = S_PLAY_DEAD
				elseif P_PlayerInPain(player)
					player.mo.state = S_PLAY_PAIN
				elseif (player.pflags&PF_JUMPED and not (player.pflags&PF_NOJUMPDAMAGE))
				or player.pflags&PF_SPINNING
					player.mo.state = S_PLAY_ROLL
				elseif player.powers[pw_carry] == CR_ROLLOUT
					player.mo.state = S_PLAY_STND
				elseif not P_IsObjectOnGround(player.mo)
					player.mo.state = S_PLAY_JUMP
				end
			elseif player.mo.jasontauntnum
				player.mo.sprite2 = SPR2_TAL0
				player.mo.frame = player.mo.jasontauntnum
			else
				player.mo.sprite2 = SPR2_TAL0
				player.mo.frame = 0
			end
		elseif player.mo.jason1tapping
			player.mo.jasonspin = false
			player.mo.jasontaunting = TICRATE*2/3
			player.mo.jasontauntnum = P_RandomRange(0,4)
			if P_RandomChance(FRACUNIT/20)
				player.mo.jasontauntnum = P_RandomRange(5,15)
			end
			if P_IsObjectOnGround(player.mo) and not player.powers[pw_carry]
			and not (player.pflags&PF_JUMPSTASIS)
			and not P_PlayerInPain(player) and player.mo.health
				player.pflags = $&~PF_JUMPED
				P_DoJump(player, false)
				player.pflags = $&~PF_STARTJUMP
				player.mo.momz = $/2
			end
			S_StartSound(player.mo, sfx_jsntnt)
			if not P_PlayerInPain(player)
				player.mo.state = S_PLAY_RIDE
			end
			player.mo.sprite2 = SPR2_TAL0
			player.mo.frame = player.mo.jasontauntnum
			local ghost = P_SpawnGhostMobj(player.mo)
			ghost.sprite2 = SPR2_TAL0
			ghost.frame = 16
			ghost.momx = player.mo.momx/2
			ghost.momy = player.mo.momy/2
			ghost.momz = player.mo.momz/2
			ghost.destscale = $*16
		end
			
		if (player.mo.boingcooldown > 0)
			player.mo.boingcooldown = $1 - 1 //jason's unique spin, not activated at the beginning.
		end
		
		if (player.mo.reflectcooldown > 0)
			player.mo.reflectcooldown = $1 - 1 //jason's unique spin, not activated at the beginning.
		end
		
		if (player.mo.reflectwindow == 12)
		and (player.mo.reflect and player.mo.reflect.valid)
			P_RemoveMobj(player.mo.reflect)
			player.mo.reflect = nil
			//print("REMOVE")
		end
		
		if (player.mo.sparkleangle > 360*FRACUNIT)
			player.mo.sparkleangle = $1 - (360*FRACUNIT) //Do a complete 360 loop to move
		end
		
		//Player has finished the level and is in exiting state
		//or player carries or being carried by something
		//or player is sliding...
		if ((player.exiting > 0) or (player.powers[pw_carry]) or ((player.mo.eflags & MFE_TOUCHWATER) and (player.mo.state == S_PLAY_PAIN)))
			player.mo.jasonspin = false
			player.mo.jasonnausea = false
		end
		
		if (player.mo.reflect and player.mo.reflect.valid)
			P_TeleportMove(player.mo.reflect, player.mo.x, player.mo.y, player.mo.z)
			player.mo.reflect.momx = player.mo.momx
			player.mo.reflect.momy = player.mo.momy
			player.mo.reflect.momz = player.mo.momz
		end
		
		
		
		//----------------------------
		//Setting the spinning's frames:
		//----------------------------
		
		
		if (player.mo.jasonspin == true)//jason spin is on?
			if (player.mo.jasonspintimer < maxamountoftime) //The maximum amount of tics you can use it
				player.mo.jasonspintimer = $1 + 1 //the timer starts running.
			end
			if (player.mo.jasonframenumber < 3) //A -> D, and again
				player.mo.jasonframenumber = $1 + 1 //go to the next frame!
			else
				player.mo.jasonframenumber = 0 //go back to A after D
			end
		elseif player.mo.jasonspintimer
			player.mo.jasonspintimer = 0 //lower the timer! to prevent overheat!
		end
		
		
		//---------------------
		//The Spinning's itself:
		//---------------------
		
		if (player.mo.jasonspin == true) //jason spin is on?
		
			if player.speed == 0
				player.pflags = $|PF_STARTDASH
			else
				player.pflags = $&~PF_STARTDASH
				local i = 0 while P_IsObjectOnGround(player.mo)
				and i <= (leveltime%7)/2 // 1, 2, 3 or 4 particles
					local particle
					if player.mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER)
						particle = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SMALLBUBBLE)
					else
						particle = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SPINDUST)
						if (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
							particle.state = S_SPINDUST_FIRE1
						end
					end
					
					particle.target = player.mo
					particle.destscale = (2*player.mo.scale)/3
					P_SetScale(particle, particle.destscale)
					if (player.mo.eflags & MFE_VERTICALFLIP) // readjust z position if needed
						particle.z = player.mo.z + player.mo.height - particle.height
					end
					local prandom = {}
					prandom[0] = P_RandomFixed()<<2 // P_RandomByte()<<10
					prandom[1] = P_RandomRange(-30, 30) // P_RandomRange(-ANG30/FRACUNIT, ANG30/FRACUNIT)*FRACUNIT
					prandom[2] = P_RandomFixed()<<3 // P_RandomByte()<<11
					P_SetObjectMomZ(particle, player.maxdash/50 + prandom[0], false)
					P_InstaThrust(particle,
							player.drawangle + (prandom[1]*ANG1),
							-FixedMul(player.maxdash/12 + FRACUNIT + prandom[2], player.mo.scale))
					particle.momx = $+player.mo.momx/2
					particle.momy = $+player.mo.momy/2
					P_TryMove(particle, particle.x+particle.momx, particle.y+particle.momy, true)
					
					i = $+1
				end
			end
		
			if (player.mo.reflectwindow < 13) //hate big numbers
				player.mo.reflectwindow = $1 + 1 //raise reflect window.
			end
			
			//The speed and jump bonus system:
			
			if player.mo.eflags & MFE_SPRUNG
				player.mo.momz = $*5/4
				player.mo.momx = $*5/4
				player.mo.momy = $*5/4
				S_StartSound(player.mo, sfx_sprong)
				if not P_IsObjectOnGround(player.mo)
					player.pflags = $|PF_JUMPED|PF_NOJUMPDAMAGE&~PF_THOKKED
				end
				player.mo.jasonspintimer = $*4/5
				player.mo.jasonspinspeed = max($, player.speed-player.mo.jasonnormalspeed)
				player.mo.jasonspinjump = player.mo.jasonspinspeed/32
			end
			
			if not (player.mo.jasonspintimer%(TICRATE*2))
			and player.mo.jasonspintimer < maxamountoftime
				S_StartSoundAtVolume(player.mo, sfx_s3ka2, 128)
				player.mo.jasonspinspeed = $1 + 8*FRACUNIT //Add some bonus speed!
				player.mo.jasonspinjump = $1 + (FRACUNIT/4) //Add some bonus jump!
				P_SetMobjStateNF(player.mo, S_JASONREFLECTSPIN1)
				if not (player.mo.reflect)
					//print("TRY TO SPAWN")
					player.mo.reflect = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_OVERLAY)
					if (player.mo.reflect.allying == nil)
						player.mo.reflect.allying = true
					end
					player.mo.reflectwindow = 0
					player.mo.reflect.scale = player.mo.scale
					player.mo.reflect.flags = (MF_FLOAT|MF_NOGRAVITY)
					player.mo.reflect.state = S_JASONREFLECTOVERLAY
				end
			end
			
			player.normalspeed = player.mo.jasonnormalspeed + player.mo.jasonspinspeed //Normal speed + Speed bonus!
			player.jumpfactor = min(player.mo.jasonjumpfactor + player.mo.jasonspinjump, player.mo.jasonjumpfactor*2) //Jump Factor + Jump bonus!
		
			//-----------------------------
			//Spawn Jason Spin ghost trail:
			//-----------------------------
			
			if not ((player.mo.momx == 0) and (player.mo.momy == 0) and (player.mo.momz == 0)) //player is moving
				if (leveltime % 2 == 0) //and every 2 tics
					//SpawnParticles(player) //(no need anymore)
					if (player.mo.jasonspinspeed > 0) //Got some speed bonus?
						if (player.mo.greenglow and player.mo.greenglow.valid)
							P_SpawnGhostMobj(player.mo.greenglow) //Spawn ghost trail!
						elseif (player.mo.madgreenglow and player.mo.madgreenglow.valid)
							P_SpawnGhostMobj(player.mo.madgreenglow) //Spawn ghost trail!
						else
							P_SpawnGhostMobj(player.mo) //Spawn ghost trail!
						end
					end
				end
			end
			
			//---------------------------
			//Change the player's height:
			//---------------------------
		
			player.height = player.spinheight //be able to go under low ceilings
			
			//------------------
			//Change the sprite:
			//------------------
			
			player.mo.sprite = SPR_PLAY //normal player sprite-
			player.mo.sprite2 = SPR2_ROLL //go into spin frames!
			player.mo.frame = player.mo.jasonframenumber //go to the exact right frame every tic.
			
			if not ((player.mo.state == S_JASONSPIN1) //the player is not in spin state?
			or      (player.mo.state == S_JASONSPIN2)
			or      (player.mo.state == S_JASONSPIN3)
			or      (player.mo.state == S_JASONSPIN4)
			or      (player.mo.state == S_JASONREFLECTSPIN1)
			or      (player.mo.state == S_JASONREFLECTSPIN2)
			or      (player.mo.state == S_JASONREFLECTSPIN3)
			or      (player.mo.state == S_JASONREFLECTSPIN4)
			or      (player.mo.state == S_JASONREFLECTSPIN5)
			or      (player.mo.state == S_JASONREFLECTSPIN6)
			or      (player.mo.state == S_JASONREFLECTSPIN7)
			or      (player.mo.state == S_JASONREFLECTSPIN8))
				player.mo.state = S_JASONSPIN1 //go to spin state!
				//print("go to special spin state")
			end
			
			
			//----------------------------------
			//When the player reaches the limit:
			//----------------------------------
			
			if (player.mo.jasonspintimer >= maxamountoftime) //reached the limit:
				
				//Get the penalty:
				player.mo.jasonnausea = true
				
				//Spawn Confusion Sparkles:
				
				if not (player.mo.confusionsparkle1)
					player.mo.confusionsparkle1 = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height, MT_GARGOYLE)
					player.mo.confusionsparkle1.flags = (MF_FLOAT|MF_NOGRAVITY|MF_NOCLIPTHING)
					player.mo.confusionsparkle1.state = S_JASONCONFUSION1
				end
				
				if not (player.mo.confusionsparkle2)
					player.mo.confusionsparkle2 = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height, MT_GARGOYLE)
					player.mo.confusionsparkle2.flags = (MF_FLOAT|MF_NOGRAVITY|MF_NOCLIPTHING)
					player.mo.confusionsparkle2.state = S_JASONCONFUSION1
				end
				
				player.mo.jasonspintimer = 0 //reset the hammer spin timer.
				player.mo.jasonspin = false //turn it off!
			end
				
		else //if not in the special spin:
		
			if (player.mo.reflect and player.mo.reflect.valid)
				P_RemoveMobj(player.mo.reflect)
				player.mo.reflect = nil
				//print("REMOVE")
			end
		
			player.pflags = ($1 &~ PF_STARTDASH)
		
			player.mo.reflectwindow = 0 //reset reflect window.
		
			player.mo.jasonspinspeed = 0 //Reset speed bonus.
			player.mo.jasonspinjump = 0 //Reset jump bonus.
			
			player.normalspeed = player.mo.jasonnormalspeed //Get your normal speed back.
			player.jumpfactor = player.mo.jasonjumpfactor //Get your jump factor back.
		
			if (player.height == player.spinheight) //right now is in spinstate height...
				player.height = player.mo.normalheight //go back to normal height.
			end
			if ((player.mo.state == S_JASONSPIN1) //is in the unique spin state?
			or  (player.mo.state == S_JASONSPIN2)
			or  (player.mo.state == S_JASONSPIN3)
			or  (player.mo.state == S_JASONSPIN4)
			or  (player.mo.state == S_JASONREFLECTSPIN1)
			or  (player.mo.state == S_JASONREFLECTSPIN2)
			or  (player.mo.state == S_JASONREFLECTSPIN3)
			or  (player.mo.state == S_JASONREFLECTSPIN4)
			or  (player.mo.state == S_JASONREFLECTSPIN5)
			or  (player.mo.state == S_JASONREFLECTSPIN6)
			or  (player.mo.state == S_JASONREFLECTSPIN7)
			or  (player.mo.state == S_JASONREFLECTSPIN8))
				player.mo.state = S_PLAY_FALL //snap out of the spin state.
			end
		end
		
		//-----------------------------------------------------------------
		//Spawn a sign to alarm the player if he's about to reach the limit:
		//-----------------------------------------------------------------
		
		if (player.mo.jasonspintimer < maxamountoftime-2*TICRATE)
			if (player.mo.additionalshadow and player.mo.additionalshadow.valid)
				P_RemoveMobj(player.mo.additionalshadow)
				player.mo.additionalshadow = nil
			end
		end
		
		if (player.mo.jasonspintimer >= maxamountoftime-2*TICRATE) //if the hammer spin move is 2 seconds away from reaching the limit-
		and (player.mo.jasonspintimer < maxamountoftime-TICRATE)
			if not (player.mo.greenglow and player.mo.greenglow.valid)
				player.mo.greenglow = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_JASONOVERLAY)
				player.mo.greenglow.skin = "jason"
				
				if not (player.mo.additionalshadow)
					player.mo.additionalshadow = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_BLUECRAWLA)
					player.mo.additionalshadow.flags = ($1|MF_NOCLIPTHING &~ MF_SHOOTABLE &~ MF_ENEMY)
					player.mo.additionalshadow.health = 6000
					player.mo.additionalshadow.state = S_VOID
					player.mo.additionalshadow.height = player.mo.height
					player.mo.additionalshadow.radius = player.mo.radius
					player.mo.additionalshadow.scale = player.mo.scale
				end
				
				player.mo.greenglow.normalspeed = player.mo.normalspeed
				player.mo.greenglow.height = player.mo.height
				player.mo.greenglow.radius = player.mo.radius
				player.mo.flags2 = ($1|MF2_DONTDRAW)
				player.mo.greenglow.rollangle = player.mo.rollangle
				player.mo.greenglow.angle = player.drawangle
				player.mo.greenglow.tics = player.mo.tics
				player.mo.greenglow.scale = player.mo.scale //(skins["jason"].highresscale/FRACUNIT)
				player.mo.greenglow.flags = (player.mo.flags|MF_NOCLIPTHING|MF_ENEMY)
				player.mo.greenglow.state = player.mo.state
				player.mo.greenglow.momx = player.mo.momx
				player.mo.greenglow.momy = player.mo.momy
				player.mo.greenglow.momz = player.mo.momz
				player.mo.greenglow.color = SKINCOLOR_GREEN
				player.mo.greenglow.colorized = true
				player.mo.greenglow.frame = player.mo.frame
				if (player.mo.eflags & MFE_VERTICALFLIP) //if the player is flipped
					P_TeleportMove(player.mo.greenglow, player.mo.x, player.mo.y, player.mo.z)
					
					if (P_MobjFlip(player.mo) < 0)
						player.mo.greenglow.eflags = $1|MFE_VERTICALFLIP //warning is flipped as well!
						player.mo.greenglow.flags2 = $1|MF2_OBJECTFLIP
					end
				else
					P_TeleportMove(player.mo.greenglow, player.mo.x, player.mo.y, player.mo.z)
				end
			else
				if (player.mo.additionalshadow and player.mo.additionalshadow.valid)
					player.mo.additionalshadow.momx = player.mo.momx
					player.mo.additionalshadow.momy = player.mo.momy
					player.mo.additionalshadow.momz = player.mo.momz
					P_TeleportMove(player.mo.additionalshadow, player.mo.x, player.mo.y, player.mo.z)
				end
				
				player.mo.greenglow.normalspeed = player.mo.normalspeed
				player.mo.greenglow.height = player.mo.height
				player.mo.greenglow.radius = player.mo.radius
				
				player.mo.flags2 = ($1|MF2_DONTDRAW)
				//player.mo.greenglow.flags2 = player.mo.flags2
				
				player.mo.greenglow.rollangle = player.mo.rollangle
				player.mo.greenglow.angle = player.drawangle
				player.mo.greenglow.tics = player.mo.tics
				player.mo.greenglow.scale = player.mo.scale //(skins["jason"].highresscale/FRACUNIT)
				player.mo.greenglow.flags = (player.mo.flags|MF_NOCLIPTHING|MF_ENEMY)
				player.mo.greenglow.state = player.mo.state
				player.mo.greenglow.momx = player.mo.momx
				player.mo.greenglow.momy = player.mo.momy
				player.mo.greenglow.momz = player.mo.momz
				player.mo.greenglow.color = SKINCOLOR_GREEN
				player.mo.greenglow.colorized = true
				player.mo.greenglow.frame = player.mo.frame
				if (player.mo.eflags & MFE_VERTICALFLIP) //if the player is flipped
					P_TeleportMove(player.mo.greenglow, player.mo.x, player.mo.y, player.mo.z)
					
					if (P_MobjFlip(player.mo) < 0)
						player.mo.greenglow.eflags = $1|MFE_VERTICALFLIP //warning is flipped as well!
						player.mo.greenglow.flags2 = $1|MF2_OBJECTFLIP
					end
				else
					P_TeleportMove(player.mo.greenglow, player.mo.x, player.mo.y, player.mo.z)
				end
			end
			if not (player.mo.warning)
				player.mo.warning = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height+20*FRACUNIT, MT_GARGOYLE)
				player.mo.warning.flags = (MF_FLOAT|MF_NOGRAVITY|MF_NOCLIPTHING)
				player.mo.warning.state = S_JASONWARNING1
				player.mo.warning.momx = player.mo.momx
				player.mo.warning.momy = player.mo.momy
				player.mo.warning.momz = player.mo.momz
				if (player.mo.eflags & MFE_VERTICALFLIP) //if the player is flipped
					P_TeleportMove(player.mo.warning, player.mo.x, player.mo.y, player.mo.z-60*FRACUNIT)
					
					if (P_MobjFlip(player.mo) < 0)
						player.mo.warning.eflags = $1|MFE_VERTICALFLIP //warning is flipped as well!
						player.mo.warning.flags2 = $1|MF2_OBJECTFLIP
					end
				else
					P_TeleportMove(player.mo.warning, player.mo.x, player.mo.y, player.mo.z+player.mo.height+20*FRACUNIT)
				end
			else
				if (player.mo.warning.state == S_JASONWARNING1)
					player.mo.warning.scale = $1 + 2225
				else
					player.mo.warning.scale = $1 - 2225
				end
				player.mo.warning.momx = player.mo.momx
				player.mo.warning.momy = player.mo.momy
				player.mo.warning.momz = player.mo.momz
				if (player.mo.eflags & MFE_VERTICALFLIP) //if the player is flipped
					P_TeleportMove(player.mo.warning, player.mo.x, player.mo.y, player.mo.z-60*FRACUNIT)
					
					if (P_MobjFlip(player.mo) < 0)
						player.mo.warning.eflags = $1|MFE_VERTICALFLIP //warning is flipped as well!
						player.mo.warning.flags2 = $1|MF2_OBJECTFLIP
					end
				else
					P_TeleportMove(player.mo.warning, player.mo.x, player.mo.y, player.mo.z+player.mo.height+20*FRACUNIT)
				end
			end
		else
			if (player.mo.greenglow and player.mo.greenglow.valid)
				P_RemoveMobj(player.mo.greenglow)
				player.mo.greenglow = nil
			end
			if (player.mo.warning and player.mo.warning.valid)
				P_RemoveMobj(player.mo.warning)
				player.mo.warning = nil
			end
		end
		
		if (player.mo.jasonspintimer >= maxamountoftime-TICRATE) //if the hammer spin move is 1 second away from reaching the limit-
			if ((player.mo.jasonspintimer-7) % 14 == 0) //every 10 tics:
				S_StartSoundAtVolume(player.mo, sfx_alarm, 130) //the sound of danger!
			end
			if not (player.mo.madgreenglow)
				player.mo.madgreenglow = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_JASONOVERLAY)
				player.mo.madgreenglow.angle = player.drawangle
				player.mo.madgreenglow.rollangle = player.mo.rollangle
				player.mo.madgreenglow.tics = player.mo.tics
				player.mo.madgreenglow.skin = "jason"
				
				if not (player.mo.additionalshadow)
					player.mo.additionalshadow = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_BLUECRAWLA)
					player.mo.additionalshadow.flags = ($1|MF_NOCLIPTHING &~ MF_SHOOTABLE &~ MF_ENEMY)
					player.mo.additionalshadow.health = 6000
					player.mo.additionalshadow.state = S_VOID
					player.mo.additionalshadow.height = player.mo.height
					player.mo.additionalshadow.radius = player.mo.radius
					player.mo.additionalshadow.scale = player.mo.scale
				end
				
				player.mo.madgreenglow.normalspeed = player.mo.normalspeed
				player.mo.madgreenglow.height = player.mo.height
				player.mo.madgreenglow.radius = player.mo.radius
				player.mo.flags2 = ($1|MF2_DONTDRAW)
				//player.mo.madgreenglow.flags2 = player.mo.flags2
				player.mo.madgreenglow.scale = player.mo.scale //(skins["jason"].highresscale/FRACUNIT)
				player.mo.madgreenglow.flags = (player.mo.flags|MF_NOCLIPTHING|MF_ENEMY)
				player.mo.madgreenglow.state = player.mo.state
				player.mo.madgreenglow.momx = player.mo.momx
				player.mo.madgreenglow.momy = player.mo.momy
				player.mo.madgreenglow.momz = player.mo.momz
				player.mo.madgreenglow.color = SKINCOLOR_APPLE
				player.mo.madgreenglow.colorized = true
				player.mo.madgreenglow.frame = player.mo.frame
				if (player.mo.eflags & MFE_VERTICALFLIP) //if the player is flipped
					P_TeleportMove(player.mo.madgreenglow, player.mo.x, player.mo.y, player.mo.z)
					
					if (P_MobjFlip(player.mo) < 0)
						player.mo.madgreenglow.eflags = $1|MFE_VERTICALFLIP //warning is flipped as well!
						player.mo.madgreenglow.flags2 = $1|MF2_OBJECTFLIP
					end
				else
					P_TeleportMove(player.mo.madgreenglow, player.mo.x, player.mo.y, player.mo.z)
				end
			else
				if (player.mo.additionalshadow and player.mo.additionalshadow.valid)
					player.mo.additionalshadow.momx = player.mo.momx
					player.mo.additionalshadow.momy = player.mo.momy
					player.mo.additionalshadow.momz = player.mo.momz
					P_TeleportMove(player.mo.additionalshadow, player.mo.x, player.mo.y, player.mo.z)
				end
				
				player.mo.madgreenglow.normalspeed = player.mo.normalspeed
				player.mo.madgreenglow.height = player.mo.height
				player.mo.madgreenglow.radius = player.mo.radius
				
				player.mo.flags2 = ($1|MF2_DONTDRAW)
				//player.mo.madgreenglow.flags2 = player.mo.flags2
				
				player.mo.madgreenglow.angle = player.drawangle
				player.mo.madgreenglow.rollangle = player.mo.rollangle
				player.mo.madgreenglow.tics = player.mo.tics
				player.mo.madgreenglow.scale = player.mo.scale //(skins["jason"].highresscale/FRACUNIT)
				player.mo.madgreenglow.flags = (player.mo.flags|MF_NOCLIPTHING|MF_ENEMY)
				player.mo.madgreenglow.state = player.mo.state
				player.mo.madgreenglow.momx = player.mo.momx
				player.mo.madgreenglow.momy = player.mo.momy
				player.mo.madgreenglow.momz = player.mo.momz
				player.mo.madgreenglow.color = SKINCOLOR_APPLE
				player.mo.madgreenglow.colorized = true
				player.mo.madgreenglow.frame = player.mo.frame
				if (player.mo.eflags & MFE_VERTICALFLIP) //if the player is flipped
					P_TeleportMove(player.mo.madgreenglow, player.mo.x, player.mo.y, player.mo.z)
					
					if (P_MobjFlip(player.mo) < 0)
						player.mo.madgreenglow.eflags = $1|MFE_VERTICALFLIP //warning is flipped as well!
						player.mo.madgreenglow.flags2 = $1|MF2_OBJECTFLIP
					end
				else
					P_TeleportMove(player.mo.madgreenglow, player.mo.x, player.mo.y, player.mo.z)
				end
			end
			if not (player.mo.madwarning)
				player.mo.madwarning = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height+20*FRACUNIT, MT_GARGOYLE)
				player.mo.madwarning.flags = (MF_FLOAT|MF_NOGRAVITY|MF_NOCLIPTHING)
				player.mo.madwarning.state = S_JASONMADWARNING1
				player.mo.madwarning.momx = player.mo.momx
				player.mo.madwarning.momy = player.mo.momy
				player.mo.madwarning.momz = player.mo.momz
				if (player.mo.eflags & MFE_VERTICALFLIP) //if the player is flipped
					P_TeleportMove(player.mo.madwarning, player.mo.x, player.mo.y, player.mo.z-60*FRACUNIT)
					
					if (P_MobjFlip(player.mo) < 0)
						player.mo.madwarning.eflags = $1|MFE_VERTICALFLIP //warning is flipped as well!
						player.mo.madwarning.flags2 = $1|MF2_OBJECTFLIP
					end
				else
					P_TeleportMove(player.mo.madwarning, player.mo.x, player.mo.y, player.mo.z+player.mo.height+20*FRACUNIT)
				end
			else
				if (player.mo.madwarning.state == S_JASONMADWARNING1)
					player.mo.madwarning.scale = $1 + 5225
				else
					player.mo.madwarning.scale = $1 - 5225
				end
				player.mo.madwarning.momx = player.mo.momx
				player.mo.madwarning.momy = player.mo.momy
				player.mo.madwarning.momz = player.mo.momz
				if (player.mo.eflags & MFE_VERTICALFLIP) //if the player is flipped
					P_TeleportMove(player.mo.madwarning, player.mo.x, player.mo.y, player.mo.z-60*FRACUNIT)
					
					if (P_MobjFlip(player.mo) < 0)
						player.mo.madwarning.eflags = $1|MFE_VERTICALFLIP //warning is flipped as well!
						player.mo.madwarning.flags2 = $1|MF2_OBJECTFLIP
					end
				else
					P_TeleportMove(player.mo.madwarning, player.mo.x, player.mo.y, player.mo.z+player.mo.height+20*FRACUNIT)
				end
			end
		else
			if (player.mo.madgreenglow and player.mo.madgreenglow.valid)
				P_RemoveMobj(player.mo.madgreenglow)
				player.mo.madgreenglow = nil
			end
			if (player.mo.madwarning and player.mo.madwarning.valid)
				P_RemoveMobj(player.mo.madwarning)
				player.mo.madwarning = nil
			end
		end
		
		
		//-----------------
		//Jason's nauseaness:
		//-----------------
		
		if (player.mo.jasonnausea == true)
		
			player.pflags = $|PF_FULLSTASIS
		
			player.mo.sparkleangle = $1 + (7*FRACUNIT) //Make the confusion sparkles spin around!
		
			if (player.mo.confusionsparkle1 and player.mo.confusionsparkle1.valid)
			
				if (player.mo.eflags & MFE_VERTICALFLIP) //if the player is flipped
					P_TeleportMove(player.mo.confusionsparkle1, player.mo.x + (cos(FixedAngle(player.mo.sparkleangle))*50), player.mo.y + (sin(FixedAngle(player.mo.sparkleangle))*50), player.mo.z - 40*FRACUNIT)
				else
					P_TeleportMove(player.mo.confusionsparkle1, player.mo.x + (cos(FixedAngle(player.mo.sparkleangle))*50), player.mo.y + (sin(FixedAngle(player.mo.sparkleangle))*50), player.mo.z + player.mo.height)
				end
				
				if (leveltime % 2 == 0) //every 2 tics:
					P_SpawnGhostMobj(player.mo.confusionsparkle1) //spawn ghost trail!
				end
			end
			
			if (player.mo.confusionsparkle2 and player.mo.confusionsparkle2.valid)
			
				if (player.mo.eflags & MFE_VERTICALFLIP) //if the player is flipped
					P_TeleportMove(player.mo.confusionsparkle2, player.mo.x + (cos(FixedAngle(player.mo.sparkleangle)+FixedAngle(180*FRACUNIT))*50), player.mo.y + (sin(FixedAngle(player.mo.sparkleangle)+FixedAngle(180*FRACUNIT))*50), player.mo.z - 40*FRACUNIT)
				else
					P_TeleportMove(player.mo.confusionsparkle2, player.mo.x + (cos(FixedAngle(player.mo.sparkleangle)+FixedAngle(180*FRACUNIT))*50), player.mo.y + (sin(FixedAngle(player.mo.sparkleangle)+FixedAngle(180*FRACUNIT))*50), player.mo.z + player.mo.height)
				end
				
				if (leveltime % 2 == 0) //every 2 tics:
					P_SpawnGhostMobj(player.mo.confusionsparkle2) //spawn ghost trail!
				end
			end
		
			if player.mo.jasonnauseatimer == 0 //when you start getting dizzy
				S_StartSoundAtVolume(player.mo, sfx_kc53, 128)
				S_StartSoundAtVolume(player.mo, sfx_kc4b, 32) //the sound of nauseaness!
			end
			
			if not ((player.mo.state == S_JASONNAUSEA1) or (player.mo.state == S_JASONNAUSEA2)) //the player is not in nausea state?
			and not (P_PlayerInPain(player)) //And player is not in pain state.
				player.mo.state = S_JASONNAUSEA1 //go to nausea state!
			end
			if (player.mo.jasonnauseatimer < nauseatimer)
				player.mo.jasonnauseatimer = $1 + 1
			else
				player.mo.jasonnauseatimer = 0 //after a few seconds, jason recovers.
				player.mo.jasonnausea = false
			end
		else
			if (player.mo.confusionsparkle1 and player.mo.confusionsparkle1.valid)
				P_RemoveMobj(player.mo.confusionsparkle1)
				player.mo.confusionsparkle1 = nil              //Get rid of confusion sparkle 1
			end
			if (player.mo.confusionsparkle2 and player.mo.confusionsparkle2.valid)
				P_RemoveMobj(player.mo.confusionsparkle2)
				player.mo.confusionsparkle2 = nil              //Get rid of confusion sparkle 2
			end
			if ((player.mo.state == S_JASONNAUSEA1) or (player.mo.state == S_JASONNAUSEA2)) //is in the nausea state?
				player.mo.state = S_PLAY_FALL //snap out of the nausea state.
			end
		end
	end
end)


//------------------------------------------------------
//Double jump junk
//------------------------------------------------------


addHook("AbilitySpecial", function(player)
	if (player.mo and player.mo.valid) //a quick check to actually check if the player exists inside the map to prevent certain "mo" warnings.
		if (player.mo.skin == "jason") //this script is only for saj so no need for any other skins.
			if player.charability == CA_DOUBLEJUMP and not (player.pflags&PF_THOKKED)
			or (player.charflags&SF_MULTIABILITY and (player.secondjump < player.actionspd >> FRACBITS))
				local z = player.mo.z
				if player.mo.eflags&MFE_VERTICALFLIP
					z = $+(player.mo.height/2)
				end
				P_SpawnParaloop(player.mo.x, player.mo.y, z,
				player.mo.radius*4, 8, MT_DUST, ANGLE_90, nil, true)
				player.mo.jasonspin = false
				player.normalspeed = player.mo.jasonnormalspeed
				player.jumpfactor = player.mo.jasonjumpfactor
				player.mo.jasontaunting = 0
			end
		end
	end
end)

//---------------------------------------------
//When you activate the spin on the ground:
//---------------------------------------------


addHook("SpinSpecial", function(player)
	if (player.mo and player.mo.valid) //a quick check to actually check if the player exists inside the map to prevent certain "mo" warnings.
		if (player.mo.skin == "jason") //this script is only for saj so no need for any other skins.
		
			local shield = player.powers[pw_shield] & SH_NOSTACK

			if P_IsObjectOnGround(player.mo)
			or player.pflags & PF_SHIELDABILITY
			or player.pflags & PF_THOKKED
			or not shield or shield == SH_PITY or shield == SH_PINK
			or not (player.cmd.buttons & BT_JUMP)
			
				if not (player.pflags&PF_USEDOWN) //the player pressed the spin button
				and (player.exiting == 0) //Player is not in the exit.
				and (player.mo.jasonnausea == false) //the player is not nausea!
				and (player.playerstate == PST_LIVE) //player is alive!
				and not (player.pflags & PF_SLIDING) //player is not sliding!
				and not (player.powers[pw_nocontrol]) //if player can move
				and not (player.pflags & PF_STASIS) //if player can move
				and not (P_PlayerInPain(player)) //if player is not in pain
				and not (player.powers[pw_carry]) //if the player is not in carry state
				
					if (player.mo.jasonspin == false) //the jason spin is not activated yet:
						S_StartSoundAtVolume(player.mo, sfx_cdfm57, 128) //the sound of spin!
						P_SetMobjStateNF(player.mo, S_JASONREFLECTSPIN1)
						if not (player.mo.reflect)
							//print("TRY TO SPAWN")
							player.mo.reflect = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_OVERLAY)
							if (player.mo.reflect.allying == nil)
								player.mo.reflect.allying = true
							end
							player.mo.reflect.scale = player.mo.scale
							player.mo.reflect.flags = (MF_FLOAT|MF_NOGRAVITY)
							player.mo.reflect.state = S_JASONREFLECTOVERLAY
						end
						player.mo.momz = $/2 //lol physics
						player.mo.jasonspin = true //trigger the special spin!
					else //it's already activated?
						player.mo.jasonspin = false //turn it off!
					end
				end
			end
			
			return true //overrides the default behavior of the spindash.
		end
	end
end)

//---------------------------------------------
//When you activate the spin on the ground:
//---------------------------------------------


addHook("ShieldSpecial", function(player)
	if not player.mo or not player.mo.valid
	or player.mo.skin ~= "jason" then
		return
	end

	local shield = player.powers[pw_shield] & SH_NOSTACK

	if shield == SH_PITY or shield == SH_PINK
	or not (player.cmd.buttons & BT_JUMP)
		return true
	end
end)

//------------------------------------------
//Disable the nausea/spin when in pain/death:
//------------------------------------------

local function JasonWhenPain(mo)
	//print("Disable the jason spin ability when pain!")
	if (mo and mo.valid) //a quick check to actually check if the player exists inside the map to prevent certain "mo" warnings.
	
		if (mo.player) //if the MT_PLAYER is actually a player-
		and (mo.skin == "jason") //this script is only for saj so no need for any other skins.
			if (mo.jasonspin == true) //in the middle of jason spin:
				mo.jasonspin = false //disable it!
			end
			mo.jasontaunting = 0
		end
		
		return false //don't override the netural behavior.
	end
end

local function JasonShouldDamage(mo, inflictor)
	if (mo and mo.valid) //a quick check to actually check if the player exists inside the map to prevent certain "mo" warnings.
	and (mo.player) //if the MT_PLAYER is actually a player-
	and (mo.skin == "jason") //this script is only for saj so no need for any other skins.
	and (mo.jasonspin == true) //in the middle of jason spin:
	and (inflictor and inflictor.valid)
	and (inflictor.flags & MF_ENEMY) //if enemy
	and (inflictor.health == 1) //and 1 health!
		return false //Don't get hit!
	end
end

local function JasonWhenDeath(mo)
	//print("Disable the jason spin ability when pain!")
	if (mo and mo.valid) //a quick check to actually check if the player exists inside the map to prevent certain "mo" warnings.
	
		if (mo.player) //if the MT_PLAYER is actually a player-
		and (mo.skin == "jason") //this script is only for saj so no need for any other skins.
			if (mo.jasonspin == true) //in the middle of jason spin:
				mo.jasonspin = false //disable it!
			end
			mo.jasontaunting = 0
			
			if (mo.reflect and mo.reflect.valid)
				P_RemoveMobj(mo.reflect)
				mo.reflect = nil
			end
			if (mo.greenglow and mo.greenglow.valid)
				P_RemoveMobj(mo.greenglow)
				mo.greenglow = nil
			end
			if (mo.madgreenglow and mo.madgreenglow.valid)
				P_RemoveMobj(mo.madgreenglow)
				mo.madgreenglow = nil
			end
			if (mo.additionalshadow and mo.additionalshadow.valid)
				P_RemoveMobj(mo.additionalshadow)
				mo.additionalshadow = nil
			end
			if (mo.warning and mo.warning.valid)
				P_RemoveMobj(mo.warning)
				mo.warning = nil
			end
			if (mo.madwarning and mo.madwarning.valid)
				P_RemoveMobj(mo.madwarning)
				mo.madwarning = nil
			end
			if (mo.confusionsparkle1 and mo.confusionsparkle1.valid)
				P_RemoveMobj(mo.confusionsparkle1)
				mo.confusionsparkle1 = nil
			end
			if (mo.confusionsparkle2 and mo.confusionsparkle2.valid)
				P_RemoveMobj(mo.confusionsparkle2)
				mo.confusionsparkle2 = nil
			end
		end
		
		return false //don't override the netural behavior.
	end
end

addHook("MobjDamage", JasonWhenPain, MT_PLAYER)
addHook("ShouldDamage", JasonShouldDamage, MT_PLAYER)
addHook("MobjDeath", JasonWhenDeath, MT_PLAYER)

local function EncounterObstacles(mo, trigger)
	if (mo and mo.valid) //a quick check to actually check if the player exists inside the map to prevent certain "mo" warnings.
	and (mo.player) //if the MT_PLAYER is actually a player-
	and (trigger and trigger.valid) //and to check if the trigger for the damage exists
	and (mo.z + mo.height >= trigger.z-20*FRACUNIT)
	and (mo.z <= trigger.z + trigger.height+20*FRACUNIT) //height difference is accurate?
	and (trigger.health > 0) //hello? still alive?
	and not (trigger == mo.additionalshadow) //NOT THE ADDITIONAL SHADOW FOR THE SPIN
		if (trigger.type == MT_GARGOYLE) //if enemy
		and (trigger.allying ~= nil) //what the heck
			return false
		end
		if (mo.skin == "jason") //this script is only for saj so no need for any other skins.
		and (mo.jasonspin == true) //the player is in jason spin state!
			//if (trigger == mo.additionalshadow) //THE ADDITIONAL SHADOW FOR THE SPIN
			//	return false //NO COLLISION
			//end
			if ((((trigger.flags & MF_ENEMY) or (trigger.flags & MF_BOSS)) and (trigger.flags & MF_SHOOTABLE)) or (trigger.flags & MF_MONITOR))
				if (trigger.flags2 & MF2_FRET)
					return false
				end
			elseif ((trigger.type == MT_SPIKE) or (trigger.type == MT_WALLSPIKE))
				mo.jasonspintimer = $*31/32
				P_KillMobj(trigger, mo, mo) //kaboom! the enemy/boss/monitor is hurt!
				return false //no real collision!
			elseif ((trigger.flags & MF_MISSILE) or (trigger.flags & MF_PAIN) or (trigger.type == MT_ENERGYBALL)) //A projectile?
			and (mo.reflectwindow <= 11)
			and (trigger.beingreflected == nil) //didn't get reflected yet.
				local counter = 0
				for i = 1, #blacklistobjects
					if (trigger.type == blacklistobjects[i])
						counter = $1 + 1
					end
				end
				if (counter == 0)
					if (trigger.beingreflected == nil)
						trigger.beingreflected = true
					end
					trigger.flags = ($1|MF_MISSILE &~ MF_PAIN)
					trigger.momx = $1 * (-1)
					trigger.momy = $1 * (-1) //Reflect it!
					trigger.momz = $1 * (-1)
					trigger.target = mo //Remember that you're the projectile's ally now!
					//S_StartSoundAtVolume(trigger, sfx_pumpkn, 100)
					S_StartSound(mo, sfx_pumpkn)
					S_StartSound(trigger, sfx_bsnipe)
					mo.reflectwindow = 0 //Reset window!
					if (mo.reflect and mo.reflect.valid)
						P_RemoveMobj(mo.reflect)
						mo.reflect = nil
					end
						
					mo.reflect = P_SpawnMobj(mo.x, mo.y, mo.z, MT_OVERLAY)
					if (mo.reflect.allying == nil)
						mo.reflect.allying = true
					end
					mo.reflect.scale = mo.scale
					mo.reflect.flags = (MF_FLOAT|MF_NOGRAVITY)
					mo.reflect.state = S_JASONREFLECTOVERLAY
					return false //no real collision!
				end
			end
		end
	end
end

addHook("MobjCollide", EncounterObstacles, MT_PLAYER)
addHook("MobjMoveCollide", EncounterObstacles, MT_PLAYER)

local function DamageSystem(player, trigger)
	if (player.mo and player.mo.valid) //a quick check to actually check if the player exists inside the map to prevent certain "mo" warnings.
	and (trigger and trigger.valid) //and to check if the trigger for the damage exists
	and (trigger.health > 0) //hello? still alive?
	and not (trigger == player.mo.additionalshadow) //NOT THE ADDITIONAL SHADOW FOR THE SPIN
		if (trigger.type == MT_GARGOYLE) //if enemy
		and (trigger.allying ~= nil) //what the heck
			return false
		end
		if (player.mo.skin == "jason") //this script is only for saj so no need for any other skins.
		and (player.mo.jasonspin == true) //the player is in jason spin state!
			//if (trigger == mo.additionalshadow) //THE ADDITIONAL SHADOW FOR THE SPIN
			//	return false //NO COLLISION
			//end
			if ((((trigger.flags & MF_ENEMY) or (trigger.flags & MF_BOSS)) and (trigger.flags & MF_SHOOTABLE)) or (trigger.flags & MF_MONITOR))
			and not (trigger.flags2 & MF2_FRET)
				//if ((trigger.health == 1) and not (trigger.flags & MF_MONITOR)) //Enemy boutta die
				//	mo.jasonspinspeed = $1 + 8*FRACUNIT //Add some bonus speed!
				//end
				if (trigger.flags & MF_ENEMY) //if enemy
				and (trigger.health == 1) //and 1 health!
					S_StartSound(trigger, sfx_pumpkn)
					trigger.momz = 10*FRACUNIT*P_MobjFlip(trigger)
					trigger.tics = -1
					trigger.momx = player.mo.momx*3/2
					trigger.momy = player.mo.momy*3/2   //Satisfying hit!
					player.mo.jasonspintimer = $*2/3
					player.mo.jasonspinspeed = $1 + 8*FRACUNIT //Add some bonus speed!
					player.mo.jasonspinjump = $1 + (FRACUNIT/4) //Add some bonus jump!
					trigger.flags = MF_MISSILE
					trigger.health = 0
					trigger.fuse = TICRATE*3
					return true
				else
					player.mo.jasonspintimer = $*2/3
					return true
				end
			else
				return true
			end
		end
	end
	if (player.mo and player.mo.valid) //a quick check to actually check if the player exists inside the map to prevent certain "mo" warnings.
	and (trigger and trigger.valid) //and to check if the trigger for the damage exists
	and (trigger.health > 0) //hello? still alive?
	and (player.mo.skin == "jason") //this script is only for saj so no need for any other skins.
	and (player.mo.jasonspin == true) //the player is in jason spin state!
	and (trigger.type == MT_METALSONIC_BATTLE)
	and not (trigger.flags & MF_PAIN)
	and not (trigger.flags2 & MF2_FRET)
		return true
	end
end
addHook("PlayerCanDamage", DamageSystem)
	

local function CheckLinesForBustables(mo, line)
	if (mo and mo.valid) //a quick check to actually check if the player exists inside the map to prevent certain "mo" warnings.
		if (mo.player) //if the MT_PLAYER is actually a player-
		and (mo.skin == "jason") //this script is only for saj so no need for any other skins.
		and (mo.jasonspin == true) //the player is in jason spin state!
		
			//Destroy Bustable FOFs in the way!
			
			if (line.frontsector and line.frontsector.valid)
			and (line.frontsector != R_PointInSubsector(mo.x, mo.y).sector)
				DestroyBustables(mo.player, line.frontsector)
			end
			
			if (line.backsector and line.backsector.valid)
			and (line.backsector != R_PointInSubsector(mo.x, mo.y).sector)
				DestroyBustables(mo.player, line.backsector)
			end
			
			return nil //also check regular collision.
		end
	end
end

addHook("MobjLineCollide", CheckLinesForBustables, MT_PLAYER)

addHook("MobjMoveBlocked", function(mo)
	if (mo and mo.valid) //a quick check to actually check if the player exists inside the map to prevent certain "mo" warnings.
		if (mo.player) //if the MT_PLAYER is actually a player-
		and (mo.skin == "jason") //this script is only for saj so no need for any other skins.
		and (mo.jasonspin == true) //the player is in jason spin state!
		and (mo.player.speed > FRACUNIT*2)
			mo.jasonspinspeed = $/2
			mo.jasonspinjump = $/2
			P_BounceMove(mo)
			S_StartSound(mo, sfx_s1b4) //Bumper sound effect
		end
	end
end, MT_PLAYER)

//Prevent bouncing on monitors when you spin into them
//Uses the monitor breaking code from the source code
addHook("MobjMoveCollide", function(tmthing, thing)
	if tmthing and tmthing.valid and tmthing.player and tmthing.skin == "jason"
	and tmthing.jasonspin and thing and thing.valid and thing.health
	and thing.flags&MF_MONITOR and not (thing.flags&MF_GRENADEBOUNCE)
	and not ((thing.type == MT_RING_REDBOX and tmthing.player.ctfteam != 1) or (thing.type == MT_RING_BLUEBOX and tmthing.player.ctfteam != 2))
	and (not (thing.flags & MF_SOLID) or P_PlayerCanDamage(tmthing.player, thing))
		if (thing.z - thing.scale <= tmthing.z + tmthing.height
		and thing.z + thing.height + thing.scale >= tmthing.z)
			local player = tmthing.player
			local flipval = P_MobjFlip(thing) // Save this value in case monitor gets removed.
			// Going down? Then bounce back up.
			if P_DamageMobj(thing, tmthing, tmthing, 1, 0) // break the monitor
			and flipval*(player.mo.momz) < 0 // monitor is on the floor and you're going down, or on the ceiling and you're going up
			and not ((player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
			and player.pflags&PF_SHIELDABILITY) // you're not piercing through the monitor...
				if (player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP
				and player.pflags&PF_SHIELDABILITY
					P_DoBubbleBounce(player)
				else
					player.mo.momz = $*-1 // Therefore, you should be thrust in the opposite direction, vertically.
				end
			end
			player.mo.z = $-player.mo.momz // to ensure proper collision.
			return false
		end
	end
end, MT_PLAYER)

local function JasonWhenQuitting(p)
	//print("Disable the jason spin ability when pain!")
	if (p.mo and p.mo.valid) //a quick check to actually check if the player exists inside the map to prevent certain "mo" warnings.
	
		if (p.mo and p.mo.valid) //if the MT_PLAYER is actually a player-
		and (p.mo.skin == "jason") //this script is only for saj so no need for any other skins.
			if (p.mo.jasonspin == true) //in the middle of jason spin:
				p.mo.jasonspin = false //disable it!
			end
			
			if (p.mo.reflect and p.mo.reflect.valid)
				P_RemoveMobj(p.mo.reflect)
				p.mo.reflect = nil
			end
			if (p.mo.greenglow and p.mo.greenglow.valid)
				P_RemoveMobj(p.mo.greenglow)
				p.mo.greenglow = nil
			end
			if (p.mo.madgreenglow and p.mo.madgreenglow.valid)
				P_RemoveMobj(p.mo.madgreenglow)
				p.mo.madgreenglow = nil
			end
			if (p.mo.additionalshadow and p.mo.additionalshadow.valid)
				P_RemoveMobj(p.mo.additionalshadow)
				p.mo.additionalshadow = nil
			end
			if (p.mo.warning and p.mo.warning.valid)
				P_RemoveMobj(p.mo.warning)
				p.mo.warning = nil
			end
			if (p.mo.madwarning and p.mo.madwarning.valid)
				P_RemoveMobj(p.mo.madwarning)
				p.mo.madwarning = nil
			end
			if (p.mo.confusionsparkle1 and p.mo.confusionsparkle1.valid)
				P_RemoveMobj(p.mo.confusionsparkle1)
				p.mo.confusionsparkle1 = nil
			end
			if (p.mo.confusionsparkle2 and p.mo.confusionsparkle2.valid)
				P_RemoveMobj(p.mo.confusionsparkle2)
				p.mo.confusionsparkle2 = nil
			end
		end
	end
end
addHook("PlayerQuit", JasonWhenQuitting)

hud.add(function(v, player, c)

	if (player.mo and player.mo.valid)

		if not (player.mo.skin == "jason") return end
		if ((c.chase and not player.jasonmeter)
		or (player.jasonmeter == 1 and not player.mo.jasonspin))
		and not splitscreen return end
		
		local down = 101
		local right = 0
		
		if v.width() > v.height()*8/5
			if v.height() == 720
				down = hudinfo[HUD_LIVES].y-52
				right = hudinfo[HUD_LIVES].x-69
			else
				down = hudinfo[HUD_LIVES].y-64
				right = hudinfo[HUD_LIVES].x-48
			end
		end
		
		//
		//nausea bar:
		//
		
		if (splitscreen == false)
			local dumb = maxamountoftime/12
		
			v.drawFill(16+right, 67+down, 1, 4, 152) //blue
			v.drawFill(17+right, 67+down, maxamountoftime/3, 1, 152) //blue
			v.drawFill(17+right, 68+down, maxamountoftime/3, 2, 31) //black
			v.drawFill(17+right+dumb, 68+down, 2, 2, 164) //purple
			v.drawFill(17+right+dumb*2, 68+down, 2, 2, 164) //purple
			v.drawFill(17+right+dumb*3, 68+down, 2, 2, 164) //purple
			v.drawFill(17+right, 70+down, maxamountoftime/3, 1, 152) //blue
			v.drawFill(17+right+maxamountoftime/3, 67+down, 1, 4, 152) //blue
			
			if (player.mo.jasonspintimer ~= nil)
				if (player.mo.jasonspintimer >= maxamountoftime-2*TICRATE)
				and (player.mo.jasonspintimer < maxamountoftime-1*TICRATE)
					v.drawFill(17+right, 68+down, player.mo.jasonspintimer/3, 2, 54) //orange
				elseif (player.mo.jasonspintimer >= maxamountoftime-1*TICRATE)
					v.drawFill(17+right, 68+down, player.mo.jasonspintimer/3, 2, 36) //red
				else
					v.drawFill(17+right, 68+down, player.mo.jasonspintimer/3, 2, 96) //green
				end
			end
			
			//v.drawString(16, 58, "NAUSEA", V_SNAPTORIGHT|V_ALLOWLOWERCASE)
			
		else
		
		//sigh...
			
			local y = -30
			local p1y = 80
			local p2y = 180
		
			for i = 0, 1
			
				if (i == 0)
					y = p1y
				else
					y = p2y
				end
				
				if (players[i].mo.skin == "jason")
			
					v.drawFill(16+right, y, 1, 4, 152) //blue
					v.drawFill(17+right, y, maxamountoftime/3, 1, 152) //blue
					v.drawFill(17+right, y+1, maxamountoftime/3, 2, 31) //black
					v.drawFill(17+right, y+3, maxamountoftime/3, 1, 152) //blue
					v.drawFill(17+right+maxamountoftime/3, y, 1, 4, 152) //blue
					
					if (players[i].mo.jasonspintimer ~= nil)
						if (players[i].mo.jasonspintimer >= maxamountoftime-2*TICRATE)
						and (players[i].mo.jasonspintimer < maxamountoftime-1*TICRATE)
							v.drawFill(17+right, y+1, players[i].mo.jasonspintimer/3, 2, 54) //orange
						elseif (players[i].mo.jasonspintimer >= maxamountoftime-1*TICRATE)
							v.drawFill(17+right, y+1, players[i].mo.jasonspintimer/3, 2, 36) //red
						else
							v.drawFill(17+right, y+1, players[i].mo.jasonspintimer/3, 2, 96) //green
						end
					end
				end
			end
		end
	end

end,"game")


